import es, wcs, keyvalues, popuplib, playerlib, sqlite3, time
from wcs import *

def unload():
	es.unregsaycmd('spendlevels')
	es.unregclientcmd('spendlevels_2')
def load():
	if not es.exists('saycommand', 'spendlevels'):
		es.regsaycmd('spendlevels', 'wcs_keyconvertor77/SpendLevels')
	if not es.exists('clientcommand', 'spendlevels_2'):
		es.regclientcmd('spendlevels_2', 'wcs_keyconvertor77/spendlevels_go')
	
	# this is the dictionary layout
	'''dict[id] = {racename:{name:{level:int,xp:int,skills:list}}}'''
	# this is the connection, pathToDatabase must be altered of course
	pathToDatabase = es.getAddonPath('wcs_keyconvertor77') + '/es_wcsdata.sqldb'
	conn = sqlite3.connect(pathToDatabase)
	# creating a cursor
	c = conn.cursor()
	# just making an empty dict to fill
	global convert_wcs
	convert_wcs = {}
	# execute the mysql query
	c.execute('select id,level from WCSUsers')
	# for each row in the result
	for row in c:
		# split the tupel (row) into the vars
		id,level = row
		# if a userid is already in the dict, update his dict
		id = id.encode('iso-8859-7').replace("'",'')
		
		if convert_wcs.has_key(id):
			# skills is splitted into a list!
			convert_wcs[id]['level'] += level
		else:
			convert_wcs[id] = {}
			convert_wcs[id]['level'] = level
		
			
	# running a loop on the dict stored from SQLDB	
	for key in convert_wcs:
		if 'BOT_' not in key:
			userkey = getSteam(key)
			if not userkey.has_key('oldlevels'):
				userkey['oldlevels'] = convert_wcs[key]['level']
	
def getSteam(steamid):
	if not wcs._dict_WCSPlayers.has_key(steamid):
		wcs._dict_WCSPlayers[steamid] = {}
		wcs._dict_WCSPlayers[steamid]['level'] = 1
		wcs._dict_WCSPlayers[steamid]['race'] = wcs.race_list[0]
		wcs._dict_WCSPlayers[steamid]['delayed race'] = 0
		wcs._dict_WCSPlayers[steamid]['last_active'] = time.time()
		wcs._dict_WCSPlayers[steamid]['name'] = 'unknown'
		wcs._dict_WCSPlayers[steamid][wcs.race_list[0]] = {}
		wcs._dict_WCSPlayers[steamid][wcs.race_list[0]]['level'] = 1
		wcs._dict_WCSPlayers[steamid][wcs.race_list[0]]['xp'] = 0
		wcs._dict_WCSPlayers[steamid][wcs.race_list[0]]['unspent skills'] = 0
		for skill in wcs.Race(wcs.race_list[0]).returnSkillList():
			if not wcs._dict_WCSPlayers[steamid][wcs.race_list[0]].has_key(skill):
				wcs._dict_WCSPlayers[steamid][wcs.race_list[0]][skill] = 0
	return wcs._dict_WCSPlayers[steamid]
def SpendLevels():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	if wcs._dict_WCSPlayers[steamid].has_key('oldlevels'):
		if wcs._dict_WCSPlayers[steamid]['oldlevels'] > 0:
			es.tell(userid, '#multi', '#lightgreen[wcs_keyconvertor77] #default- You have #green%s#default levels to spend.'%wcs._dict_WCSPlayers[steamid]['oldlevels'])
			es.tell(userid, '#multi', '#lightgreen[wcs_keyconvertor77] #default- Press escape and input an amount an amount of levels to spend.')
			es.escinputbox(30, userid, 'wcs_keyconvertor77', 'Enter levels to spend', 'spendlevels_2')
		else:
			es.tell(userid, '#multi', '#lightgreen[wcs_keyconvertor77] #default- You have no levels to spend.')
def spendlevels_go():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	try:
		int(es.getargv(1))
	except ValueError:
		es.tell(userid, '#multi', '#lightgreen[wcs_keyconvertor77] #default- You must input a number.')
		return 0
 	arg2 = int(es.getargv(1))
	if arg2 <= wcs._dict_WCSPlayers[steamid]['oldlevels']:
		wcs._dict_WCSPlayers[steamid]['oldlevels'] -= arg2
		wcs.Command(userid).GiveLevel(arg2)
	else:
		es.tell(userid, '#multi', '#defaultYou do not have #lightgreen%s unspent old levels!'%arg2)
		
def player_spawn(ev):
	userid = int(ev['userid'])
	steamid = playerlib.getPlayer(userid).get('steamid')
	if wcs._dict_WCSPlayers[steamid].has_key('oldlevels'):
		if wcs._dict_WCSPlayers[steamid]['oldlevels'] > 0:
			es.tell(userid, '#multi', '#lightgreen[wcs_keyconvertor77] #default- You have levels to spend.  Type spendlevels to access them.')
	